package router

import (
	"github.com/gin-gonic/gin"
	"onvif-agent/router/handler/onvif"
)

func SetupRoutes(r *gin.Engine) {
	// ONVIF 相关路由
	userGroup := r.Group("/onvif")
	{
		connectionGroup := userGroup.Group("/connections")
		{
			connectionGroup.POST("/", onvif.CreateConnection)
			connectionGroup.GET("/", onvif.GetConnections)
			connectionGroup.GET("/:xaddr", onvif.GetConnectionByXaddr)
			connectionGroup.DELETE("/:xaddr", onvif.DeleteConnection)
		}

		subscriptionGroup := userGroup.Group("/subscriptions")
		{
			subscriptionGroup.POST("/:xaddr", onvif.CreateEventSubscription)
			subscriptionGroup.POST("/callback", onvif.EventNotifyCallback)
		}
	}
}
